#-*-coding: utf-8 -*-
from Tkinter import *
import os,sys

DIR=0
PIC=1
rezim_obrazku=False
import Image,ImageTk

if len(sys.argv)==1:sys.argv.append("./")
if len(sys.argv)==2:
    try:os.chdir(sys.argv[1])
    except:print u"Nemohu najít adresář %s"%sys.argv[0]
elif len(sys.argv)>2:
    print "Usage: %s [dirname]"%sys.argv[0]
    sys.exit()

def projdi():
    soubory=os.listdir("./")
    global sou
    sou=[] #pole, kam se budou ukladat hodici se soubory
    for i in soubory:
        try: #vyzkousi, jesli je to adresar
            os.listdir(i)
            os.listdir("..")
            sou.append([i,DIR])
        except:
            if len(i)>=4:
                if i[-4:]==".jpg":
                    sou.append([i,PIC])
            elif len(i)>=5:
                if i[-5:]==".jpeg":
                    sou.append([i,PIC])

def nahoru(*args):
    global zacatek
    zacatek=0
    os.chdir("..")
    projdi()
    vykresli(0)
def pred(*args):
    global zacatek
    if zacatek>=MAX_RADKU*MAX_SLOUPCU:
        zacatek-=MAX_RADKU*MAX_SLOUPCU
        vykresli(zacatek)
def nasl(*args):
    global zacatek
    if zacatek+MAX_RADKU*MAX_SLOUPCU<len(sou):
        zacatek+=MAX_RADKU*MAX_SLOUPCU
        vykresli(zacatek)

class Zmen_dir:
    def __init__(self,x,y):
        self.x=x
        self.y=y
        
    def __call__(self,*args):
        dir=jmena[(self.x,self.y)]
        if not(dir is None):
            os.chdir(dir)
            projdi()
            vykresli(0)

projdi()

main=Tk()
main.title("Prohlížeč obrázků")
def klavesa(e):
    if(e.keycode)==9:sys.exit()
    if(e.keycode)==13:
        rezim_obrazku=not rezim_obrazku
main.bind("<KeyPress>",klavesa)
MAX_RADKU=5
MAX_SLOUPCU=5
zacatek=0 #prvni zobrazovany objekt
obj={}
jmena={} #Obsahuje jmena adresaru, na ktere odkazuji Framy
oldimages={}
for i in range(0,MAX_RADKU):
    for j in range(0,MAX_SLOUPCU):
        obj[(i,j)]=[]
        oldimages[(i,j)]=None
        new_frame=Frame(main,relief=SUNKEN,bd=1)
        new_frame.grid(row=i,column=j)
        obj[(i,j)].append(new_frame)
        label1=Label(new_frame)
        label1.grid(row=0,column=0)
        obj[(i,j)].append(label1)
        name=Label(new_frame)
        name.grid(row=1,column=0)
        obj[(i,j)].append(name)
        size=Label(new_frame)
        size.grid(row=2,column=0)
        obj[(i,j)].append(size)
        funkce=Zmen_dir(i,j)
        new_frame.bind("<1>",funkce)
        label1.bind("<1>",funkce)
        name.bind("<1>",funkce)
        size.bind("<1>",funkce)
        vyse=Button(main,text="O adresář výše",command=nahoru)
        vyse.grid(row=MAX_RADKU,column=0)
        predchozi=Button(main,text="Předchozí strana",command=pred)
        predchozi.grid(row=MAX_RADKU,column=1)
        nasledujici=Button(main,text="Následující strana",command=nasl)
        nasledujici.grid(row=MAX_RADKU,column=2)
        if MAX_RADKU*MAX_SLOUPCU>len(sou):uk=len(sou)
        else:uk=MAX_RADKU*MAX_SLOUPCU
        info=Label(main,text="Zobrazuji 1-%d z %d"%(uk,len(sou)))
        info.grid(row=MAX_RADKU,column=3)
        obj[(i,j)].append(info)
        

def vykresli(zacatek): #Prepise vsechny zobrazovane hodnoty
    global obj,jmena,oldimages
    for i in range(0,MAX_RADKU):
        for j in range(0,MAX_SLOUPCU):
          try:
            if zacatek+MAX_RADKU*MAX_SLOUPCU>len(sou):uk=len(sou)
            else:uk=MAX_RADKU*MAX_SLOUPCU+zacatek
            obj[(i,j)][4].config(text="Zobrazuji %d-%d z %d"%(zacatek+1,uk,len(sou)))
            cislo=zacatek+i*MAX_SLOUPCU+j
            if cislo>=len(sou):
                obj[(i,j)][0].config(bd=0)
                try:
                    obj[(i,j)][1].config(text="")
                except:pass
                obj[(i,j)][2].config(text="")
                obj[(i,j)][3].config(text="")
                jmena[(i,j)]=None
                continue
            obj[(i,j)][0].config(bd=1)
            if sou[cislo][1]==DIR:
                obj[(i,j)][1].destroy()
                obj[(i,j)][1]=Label(obj[(i,j)][0],text="Vstup do adresáře")
                obj[(i,j)][1].grid(row=0,column=0)
                obj[(i,j)][0].config(relief=RAISED)
                jmena[(i,j)]=sou[cislo][0]
            else: #Jinak je to obrazek
                obj[(i,j)][1].destroy()
                img=Image.open("./"+sou[cislo][0])
                img.size=(100,100)
                photo=ImageTk.PhotoImage(img)
                
                obj[(i,j)][1]=Button(obj[(i,j)][0],image=photo)
                obj[(i,j)][1].grid(row=0,column=0)
                jmena[(i,j)]=None
                del photo,img
            obj[(i,j)][2].config(text="Jméno: %s"%sou[cislo][0])
            
            velikost=os.stat(sou[cislo][0])[6]
            if velikost>1024**2:
                obj[(i,j)][3].config(text="Velikost: %.3f MB"%(velikost/(1024.**2)))
            else:
                obj[(i,j)][3].config(text="Velikost: %.3f kB"%(velikost/(1024.)))
          except:continue

vykresli(0)
main.mainloop()
